﻿/*
 * 以圖形繪製說明多型的應用
 * 10/9/2008
 */

using System;

namespace DrawingAllShapes
{
    class Program
    {
        static void Main(string[] args)
        {
            Shape[] list = new Shape[2];
            Point center;
            center.x = 15;
            center.y = 20;
            Point topLeft;
            topLeft.x = 30;
            topLeft.y = 40;
            Circle c = new Circle(2, center);
            Rectangle r = new Rectangle(3, 4, topLeft);
            Console.WriteLine("決定畫圖順序, 輸入");
            Console.WriteLine("1: 圓形, 矩形");
            Console.WriteLine("2: 矩形, 圓形");
            int ans = int.Parse(Console.ReadLine());
            switch (ans)
            {
                case 1:
                    list[0] = c;
                    list[1] = r;
                    break;
                case 2:
                    list[0] = r;
                    list[1] = c;
                    break;
                default:
                    list[0] = c;
                    list[1] = r;
                    break;
            }
            DrawAllShapes(list);
        }
        static void DrawAllShapes(Shape[] list)
        {
            int i;
            for (i = 0; i < list.Length; ++i)
            {
                list[i].Draw();
            }
        }
    }
    struct Point
    {
        public int x;
        public int y;
    }
    class Shape
    {
        public Shape() { }
        virtual public void Draw() { }
    }
    class Circle : Shape
    {
        private int radius;
        private Point center;
        public Circle(int radius, Point center)
        {
            this.radius = radius;
            this.center = center;
        }
        override public void Draw()
        {
            Console.WriteLine("Draw a circle");
        }
    }
    class Rectangle : Shape
    {
        private int width;
        private int height;
        private Point topLeft;
        public Rectangle(int width, int height, Point topLeft)
        {
            this.width = width;
            this.height = height;
            this.topLeft = topLeft;
        }
        override public void Draw()
        {
            Console.WriteLine("Draw a rectangle");
        }
    }
}
